import { ChangeDetectorRef, Input, Injectable } from '@angular/core';
import * as _ from 'lodash-es';
import { ComponentHoodClass } from './component-hood.class';
import { PrismService } from './prism.service';
export class PrismHoodClass extends ComponentHoodClass {
    constructor(changeDetectorRef, prismService) {
        super();
        this.changeDetectorRef = changeDetectorRef;
        this.prismService = prismService;
        this.change = false;
        this.async = false;
    }
    set hooks(value) {
        this._hooks = value;
        if (value instanceof Object) {
            _.forEach(value, (element, key) => {
                this.prismService.hooks().add(key, element);
            });
        }
    }
    get hooks() {
        return this._hooks;
    }
    set language(value) {
        if (value) {
            if (typeof (value) === 'string') {
                this._language = value;
            }
            else {
                throw new Error(`Property \`language\` should be \`string\` instead of provided \`${typeof (value)}\``);
            }
        }
        else {
            throw new Error('Missing property `language`.');
        }
    }
    ;
    get language() {
        return this._language;
    }
    highlightElement(change = false) {
        if (this.change === change) {
            this.prismService.highlight(this.el, {
                async: this.async,
                callback: this.callback,
                code: this.code,
                interpolation: this.interpolation
            });
            this.change = false;
        }
    }
}
PrismHoodClass.decorators = [
    { type: Injectable },
];
PrismHoodClass.ctorParameters = () => [
    { type: ChangeDetectorRef, },
    { type: PrismService, },
];
PrismHoodClass.propDecorators = {
    'async': [{ type: Input, args: ['async',] },],
    'callback': [{ type: Input, args: ['callback',] },],
    'code': [{ type: Input, args: ['code',] },],
    'hooks': [{ type: Input, args: ['hooks',] },],
    'language': [{ type: Input, args: ['language',] },],
    'interpolation': [{ type: Input, args: ['interpolation',] },],
};
//# sourceMappingURL=prism.class.js.map