import { ChangeDetectorRef, ChangeDetectionStrategy, Component, ViewEncapsulation } from '@angular/core';
import { PrismHoodClass } from './prism.class';
import { PrismService } from './prism.service';
export class PrismComponent extends PrismHoodClass {
    constructor(changeDetectorRef, prismService) {
        super(changeDetectorRef, prismService);
        this.changeDetectorRef = changeDetectorRef;
        this.prismService = prismService;
    }
    ngAfterViewChecked() {
        this.highlightElement(true);
    }
    ngOnChanges(changes) {
        this.onChanges(['code', 'language'], changes, (detectedChanges) => {
            this.change = true;
        });
    }
}
PrismComponent.decorators = [
    { type: Component, args: [{
                changeDetection: ChangeDetectionStrategy.OnPush,
                encapsulation: ViewEncapsulation.None,
                providers: [PrismService],
                selector: 'prism-highlight',
                template: `<pre class="language-{{language}}" *ngIf="language"><code #el class="language-{{language}}"><ng-content *ngIf="!code"></ng-content></code></pre>`
            },] },
];
PrismComponent.ctorParameters = () => [
    { type: ChangeDetectorRef, },
    { type: PrismService, },
];
//# sourceMappingURL=prism.component.js.map